function odcinek_bresenham3(xp,yp,xk,yk)
    % Funkcja realizujaca algorytm Bresenhama rysowania
    % odcinka o dowolnym nachyleniu

    dx = xk - xp;
    dy = yk - yp;
    
    sx = sign(dx);
    sy = sign(dy);
    dx = abs(dx);
    dy = abs(dy);
    
    if (abs(dy/dx)<1)
        pE = 2*dy;
        pNE = 2*(dy - dx);
        d = 2*dy - dx;

        x = xp;
        y = yp;
        
        for i = 0 : dx
            set_pixel(x,y);
            
            x = x + sx;    
            if (d<0)
                d = d + pE;
            else
                y = y + sy;        
                d = d + pNE;
            end;

        end;
    else
        pS = 2*dx;
        pSE = 2*(dx - dy);
        d = 2*dx - dy;

        x = xp;
        y = yp;
        
        for i = 0 : dy
            set_pixel(x,y);
            
            y = y + sy;    
            if (d<0)
                d = d + pS;
            else
                x = x + sx;        
                d = d + pSE;
            end;
        end;
    end;

    return;
